/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.wpa.webservices.jaxws;

import cz.cvut.kbss.wpa.webservices.model.Book;
import cz.cvut.kbss.wpa.webservices.service.BookServiceIface;
import java.util.List;
import javax.jws.WebMethod;
import javax.jws.WebService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 *
 * @author marek
 */
@Component("wsBookService")
@WebService
public class WsBookService {
    
    @Autowired
    private BookServiceIface bookService;
    
    @WebMethod
    public String getHello() {
        return "hello";
    }
    
    @WebMethod
    public List<Book> getAllBooks() {
        return bookService.getAllBooks();
    }

    @WebMethod
    public Book getBookById(long id) {
        return bookService.getBookById(id);
    }

    @WebMethod
    public List<Book> getBooksByOwnerAge(int min, int max) {
        return bookService.getBooksByOwnerAge(min, max);
    }

    @WebMethod
    public List<Book> getBooksByOwnerName(String name) {
        return bookService.getBooksByOwnerName(name);
    }

    @WebMethod
    public List<Book> getBooksByTitle(String title) {
        return bookService.getBooksByTitle(title);
    }
    
    @WebMethod
    public void addBook(Book book) {
        bookService.addBook(book);
    }
    
    @WebMethod
    public void removeBook(long id) {
        bookService.removeBook(id);
    }
    
    @WebMethod
    public void updateBook(long id, Book book) {
        bookService.updateBook(id, book);
    }
    
}
