/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.cvut.kbss.wpa.webservices.spring.rest;

import cz.cvut.kbss.wpa.webservices.model.Book;
import cz.cvut.kbss.wpa.webservices.model.User;
import cz.cvut.kbss.wpa.webservices.service.BookServiceIface;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;

/**
 *
 * @author marek
 */
@Controller
@RequestMapping("/books")
public class RestBookService {
    
    @Autowired
    private BookServiceIface bookService;

    @RequestMapping(value="/hello", method= RequestMethod.GET)
    @ResponseBody
    public String getHello() {
        return "hello";
    }

    @RequestMapping(method= RequestMethod.GET, produces={"application/json"})
    @ResponseBody
    public List<Book> getAllBooks() {
        return bookService.getAllBooks();
    }
    
    @RequestMapping(value="/{id}", method= RequestMethod.GET, produces={"application/json", "application/xml"})
    @ResponseBody
    public Book getBookById(@PathVariable("id") long id) {
        return bookService.getBookById(id);
    }

    @RequestMapping(value="/{minAge}/{maxAge}", method= RequestMethod.GET, produces={"application/json"})
    @ResponseBody
    public List<Book> getBooksByOwnerAge(@PathVariable("minAge") int min, @PathVariable("maxAge") int max) {
        return bookService.getBooksByOwnerAge(min, max);
    }
    
    
    @RequestMapping(method= RequestMethod.POST, params={"title"})
    @ResponseStatus(HttpStatus.CREATED)
    public void addBook(@RequestParam("title") String title, @RequestParam("ownerUserName") String ownerUserName, @RequestParam("ownerAge") int ownerAge) {
        User user = new User(9, ownerUserName, ownerAge);
        Book book = new Book(99, title, user);
        bookService.addBook(book);
    }

    @RequestMapping(method= RequestMethod.POST, consumes={"application/json", "application/xml"})
    @ResponseStatus(HttpStatus.CREATED)
    public void addBook(@RequestBody Book book) {
        bookService.addBook(book);
    }
    
}
